;*********************************************************************
;dwell timer, ign_out timer
; $Id: isr_ign.s,v 1.70 2013/12/13 00:35:40 jsmcortina Exp $
; * Copyright 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013
; * James Murray and Kenneth Culver
; *
; * This file is a part of MS2/Extra.
; *
; * Origin: James Murray / Kenneth Culver
; * Majority: James Murray / Kenneth Culver
; *
; * You should have received a copy of the code LICENSE along with this source,
; * ask on the www.msextra.com forum if you did not.
; *

;.sect .text (see below)
.globl ISR_Dwl_TimerOut, ISR_TC5, ISR_Ign_TimerOut, ISR_Rot_TimerOut, ISR_Rot_SpkTimerOut, ISR_Inj3_TimerOut, ISR_Inj4_TimerOut
.globl fire_coil, dwell_coil_cut, fire_coil_rotary, dwell_coil_rotary, do_complog_pri, seq_inj_ctrl
.globl tt2d_sub, tt2s_sub
.globl checkforspk, checkfortimerin, checkforsci
.globl random_no

             nolist               ;turn off listing
             include "ms2extrah.inc"
             list                 ;turn listing back on

;*********************************************************************
.sect .text
ISR_Rot_TimerOut:  ; dwell
   brset   seq_inj_ctrl,#0x01,do_rot ; With standard injectors do the rotary ignition
   jmp     ISR_Inj3_TimerOut
do_rot:
   movb    #TFLG_rotINJ3,TFLG1  ; *** JB was 0x80
   bclr    TIE,#TFLG_rotINJ3    ; *** JB was 0x80
   ldab    spkmode
   cmpb    #14
   bne     do_do_rot
   bra     tt2d
do_do_rot:
    brset   flash4.EngStroke,#3,dd_rot2 ; do not try to use brclr
    bra     rot_timerout_end
dd_rot2:
   ldaa	   spkcut_thresh    ; Spark cut for rotary just turns off trailing completely
   bne	   rot_timerout_end
   bsr     dwell_coil_rotary

rot_timerout_end:
   clr     rotarydwlsel
   rti

;*********************************************************************
dwell_coil_rotary:
   brset   flash4.ICIgnOption,#0x10,rotdwllo
   brset   flash10.RotarySplitMode,#0x01,FDDwl
   brset   rotarydwlsel,0x4,FCDwl
   brset   rotarydwlsel,0x8,FCDwl
   bra     dcr_end

FDDwl:
   brset   rotarydwlsel,0x4,FCDwl  ;reuse FCDwl
   brset   rotarydwlsel,0x8,FDDwlD
   bra     dcr_end

FDDwlD:
.ifdef MICROSQUIRT
   bset    PTM, #0x20
.else
   bclr    PTM, #0x20
.endif
    movb    maxdwl, rdwl+1
   bra     dcr_end

FCDwl:
.ifdef MICROSQUIRT
   bclr    PTT, #0x10
.else
   bclr	   PTM, #0x10
.endif
    movb    maxdwl, rdwl

dcr_end:
   clr     rotarydwlsel
   rts

rotdwllo:
   brset   flash10.RotarySplitMode,#0x01,FDDwllo
   brset   rotarydwlsel,0x4,FCDwllo
   brset   rotarydwlsel,0x8,FCDwllo
   bra     dcr_end

FDDwllo:
   brset   rotarydwlsel,0x4,FCDwllo  ;reuse FCDwl
   brset   rotarydwlsel,0x8,FDDwlDlo
   bra     dcr_end

FDDwlDlo:
.ifdef MICROSQUIRT
   bclr    PTM, #0x20
.else
   bset    PTM, #0x20
.endif
    movb    maxdwl, rdwl+1
   bra     dcr_end

FCDwllo:
.ifdef MICROSQUIRT
   bset    PTT, #0x10
.else
   bset	   PTM, #0x10
.endif   
    movb    maxdwl, rdwl
   bra     dcr_end

;*********************************************************************

ISR_Rot_SpkTimerOut:
   brset   seq_inj_ctrl,#0x01,do_rot_spk ; With standard injectors do the rotary ignition
   jmp     ISR_Inj4_TimerOut
do_rot_spk:
   movb    #TFLG_rotINJ4,TFLG1
   bclr    TIE,#TFLG_rotINJ4
   ldab    spkmode
   cmpb    #14
   bne     do_do_rot_spk
   bra     tt2s
do_do_rot_spk:
    brset   flash4.EngStroke,#3,dd_rot_spk2
    bra     rot_spk_end
dd_rot_spk2:
   ldaa	   spkcut_thresh
   bne	   spk_cut_rot 
   bsr     fire_coil_rotary
   bra     rot_spk_end
spk_cut_rot:
.ifdef MICROSQUIRT
   bset    PTT, #0x10
   bclr    PTM, #0x20
.else
   bset    PTM, #0x10
   bset    PTM, #0x20
.endif

rot_spk_end:
   clr     rotaryspksel
   rti

;*********************************************************************
fire_coil_rotary:
   brset   flash4.ICIgnOption,#0x10,rotspkhi
   brset   flash10.RotarySplitMode,#0x01,FDFire
   brset   rotaryspksel,0x4,FCFireC
   brset   rotaryspksel,0x8,FCFireD
   bra     fcr_end

FDFire:
   brset   rotaryspksel,0x4,FDFireC
   brset   rotaryspksel,0x8,FDFireD
   bra     fcr_end

FDFireC:
.ifdef MICROSQUIRT
   bset    PTT, #0x10
.else
   bset    PTM, #0x10
.endif
    clr     rdwl
   bra     fcr_end

FDFireD:
.ifdef MICROSQUIRT
   bclr    PTM, #0x20
.else
   bset    PTM, #0x20
.endif
    clr     rdwl+1
   bra     fcr_end

FCFireC:
.ifdef MICROSQUIRT
   bset    PTM, #0x20
   bset    PTT, #0x10
.else
   bclr    PTM, #0x20
   bset    PTM, #0x10
.endif
    clr     rdwl
    clr     rdwl+1 ; clear both channels due to select
   bra     fcr_end

FCFireD:
.ifdef MICROSQUIRT
   bclr    PTM, #0x20
   bset    PTT, #0x10
.else
   bset    PTM, #0x20
   bset    PTM, #0x10
.endif
    clr     rdwl
    clr     rdwl+1 ; clear both channels due to select
fcr_end:
   clr     rotaryspksel
   rts

rotspkhi:
   brset   flash10.RotarySplitMode,#0x01,FDFirehi
   brset   rotaryspksel,0x4,FCFireChi
   brset   rotaryspksel,0x8,FCFireDhi
   bra     fcr_end

FDFirehi:
   brset   rotaryspksel,0x4,FDFireChi
   brset   rotaryspksel,0x8,FDFireDhi
   bra     fcr_end

FDFireChi:
.ifdef MICROSQUIRT
   bclr    PTT, #0x10
.else
   bclr    PTM, #0x10
.endif
    clr     rdwl
   bra     fcr_end

FDFireDhi:
.ifdef MICROSQUIRT
   bset    PTM, #0x20
.else
   bclr    PTM, #0x20
.endif
    clr     rdwl+1
   bra     fcr_end

FCFireChi:
.ifdef MICROSQUIRT
   bclr    PTM, #0x20
   bclr    PTT, #0x10
.else
   bclr    PTM, #0x20
   bclr    PTM, #0x10
.endif
    clr     rdwl
    clr     rdwl+1 ; clear both channels due to select
   bra     fcr_end

FCFireDhi:
.ifdef MICROSQUIRT
   bset    PTM, #0x20
   bclr    PTT, #0x10
.else
   bset    PTM, #0x20
   bclr    PTM, #0x10
.endif
    clr     rdwl
    clr     rdwl+1 ; clear both channels due to select
   bra     fcr_end

;*********************************************************************
;Twin trigger second channel
;*********************************************************************

;Spark
tt2s:
    bsr     tt2s_sub
    ldd     dwell_us2
    tbeq    d,tt2s_exit
    addd    TC_rotINJ4  ; read rot. spark timer that got us here
    std     TC_rotINJ3  ; set up rot. dwell timer for prescribed time later
    bset    TIE,#TFLG_rotINJ3
    movb    #TFLG_rotINJ3,TFLG1
    movb    #1, rotarydwlsel
tt2s_exit:
    rti

;Dwell
tt2d:
    ldab    spkcut_thresh
    beq     tt2d_b      ;  no spark cut
;spk cut timer

    ldaa    rand_ptr
    inc     rand_ptr
    
    tfr     a,x
    ldaa    random_no, x
    cba
    bls     tt2d_exit   ; don't set dwell

tt2d_b:
    bsr     tt2d_sub

tt2d_exit:
    rti

tt2s_sub:
    tst     rotaryspksel
    beq     tt2d_sub_exit
    clr     rotaryspksel
    clr     rdwl
    brclr   flash4.ICIgnOption,#0x10,tt2d1
    bra     tt2d0

tt2d_sub:
    tst     rotarydwlsel
    beq     tt2d_sub_exit
    clr     rotarydwlsel
    movb    maxdwl, rdwl

    brclr   flash4.ICIgnOption,#0x10,tt2d0
tt2d1:
.ifdef MICROSQUIRT
    bset    PTT, #0x10
.else
    bset    PTM, #0x10
.endif
    bra     tt2d_sub_exit
tt2d0:
.ifdef MICROSQUIRT
    bclr    PTT, #0x10
.else
    bclr    PTM, #0x10
.endif

tt2d_sub_exit:
    rts

;*********************************************************************
.sect .text

ISR_Dwl_TimerOut:
   movb    #TFLG_dwl,TFLG1 ; clear interrupt flag
   bclr    TIE,#TFLG_dwl

;   bclr    outpc.status3, #2 ; ?
   ldab    spkmode
   cmpb    #2
   blo     idt_dn  ; shouldn't have got here in EDIS mode

; set dwell timers (even if we actually skip the dwell)
   brset   dwellsel,2,dwlt2
   brset   dwellsel,4,dwlt4
   brset   dwellsel,8,dwlt8
   brset   dwellsel,0x10,dwlt10
   brset   dwellsel,0x20,dwlt20
   ldx     #0
   bra     setdwlt
dwlt2:
   ldx     #1
   bra     setdwlt
dwlt4:
   ldx     #2
   bra     setdwlt
dwlt8:
   ldx     #3
   bra     setdwlt
dwlt10:
   ldx     #4
   bra     setdwlt
dwlt20:
   ldx     #5

setdwlt:
   ldaa    maxdwl
   staa    dwl,x

   bsr     dwell_coil_cut

idt_dn:
   rti
;*********************************************************************
;dwell coil with spkcut checking
dwell_coil_cut:
   ldab    spkcut_thresh
   beq     dwell_coil    ; no spark cut
    ldaa    rand_ptr
    inc     rand_ptr
    
    tfr     a,x
    ldaa    random_no, x
    cba
   bhi     dwell_coil
   clr     dwellsel
   rts
;*********************************************************************
dwell_coil:
   tst     dwellsel
   beq     idclrcoil
   brset   flash4.ICIgnOption,#0x10,nidhilo0
   jmp     idhilo0
nidhilo0:
    brset   flash4.EngStroke,#3,chkrotdwl1
   brset   flagbyte11,#FLAGBYTE11_DLI4,jdlidwl1
   brset   flagbyte11,#FLAGBYTE11_DLI6,jdlidwl1
   brset   dwellsel,1,idh1c1
   brset   dwellsel,2,idh1c2
   brset   dwellsel,4,idh1c3
   brset   dwellsel,8,idh1c4
   brset   dwellsel,0x10,idh1c5
   brset   dwellsel,0x20,idh1c6
   bra     idclrcoil

jdlidwl1:  jmp     dlidwl1

chkrotdwl1:
   brclr   flagbyte11,#FLAGBYTE11_RX8,idh1c1
   brset   dwellsel,1,idh1c1
   brset   dwellsel,2,idh1c4rx8
   bra     idclrcoil
idh1c1:
   bclr    dwellsel,#1
idh1c1b:
   brclr   flagbyte11, #FLAGBYTE11_JS10, idc1d14
;idc1js10:
   bset    PTT, #0x20
   bra     idc1com
idc1d14:
.ifdef MICROSQUIRT
   bclr    PTM, #0x20 ; WLED ; as of 2013-08-28 polarity outside ECU matches IGN1
.else
   bset    PTM, #0x08
.endif
idc1com:
   bclr    dwellsel,#1
    brset   flash4.EngStroke,#3,idc1d14b
   bra     dwell_coil
idc1d14b:
   jmp     idclrcoil
idh1c2:
   bclr    dwellsel,#2
   brset   flagbyte4,#flagbyte4_oddspk,idh1c1b
.ifdef MICROSQUIRT
   bset    PTT, #0x10
.else
   bset    PTM, #0x10
.endif
   bra     dwell_coil
idh1c3:
.ifdef MICROSQUIRT
   bclr    PTM, #0x20
.else
   bset    PTM, #0x20
.endif
   bclr    dwellsel,#4
   bra     dwell_coil
idh1c4:
.ifdef MICROSQUIRT
   bclr    PTM, #0x10
.else
   bset    PORTA, #0x01
.endif
   bclr    dwellsel,#8
   bra     dwell_coil
idh1c4rx8:
.ifdef MICROSQUIRT
   bclr    PTM, #0x10
.else
   bset    PORTA, #0x01
.endif
   bclr    dwellsel,#2
   bra     dwell_coil
idh1c5:
   bset    PTAD, #0x40
   bclr    dwellsel,#0x10
   bra     dwell_coil
idh1c6:
   bset    PTAD, #0x80
   bclr    dwellsel,#0x20
   bra     dwell_coil

; DLI
dlidwl1:
.ifdef MICROSQUIRT
   bset    PTT, #0x20
.else
   bset    PTM, #0x08
.endif

; only need to alter IGt (clock) output on dwell event. Select is set on spark event
   jmp     idclrcoil

;--------

idhilo0:
    brset   flash4.EngStroke,#3,chkrotdwl2
   brset   flagbyte11,#FLAGBYTE11_DLI4,jdlidwl0
   brset   flagbyte11,#FLAGBYTE11_DLI6,jdlidwl0
   brset   dwellsel,1,idh0c1
   brset   dwellsel,2,idh0c2
   brset   dwellsel,4,idh0c3
   brset   dwellsel,8,idh0c4
   brset   dwellsel,0x10,idh0c5
   brset   dwellsel,0x20,idh0c6
   bra     idclrcoil

jdlidwl0:  jmp     dlidwl0

chkrotdwl2:
   brclr   flagbyte11,#FLAGBYTE11_RX8,idh0c1
   brset   dwellsel,1,idh0c1
   brset   dwellsel,2,idh0c4rx8
   bra     idclrcoil

idh0c1:
   brclr   flagbyte11, #FLAGBYTE11_JS10, idh0c1d14
;dh0c1js10:
   bclr    PTT, #0x20
   bra     idh0c1com
idh0c1d14:
.ifdef MICROSQUIRT
   bset    PTM, #0x20 ; WLED ; as of 2013-08-28 polarity outside ECU matches IGN1
.else
   bclr    PTM, #0x08
.endif
idh0c1com:
   bclr    dwellsel,#1
    brset   flash4.EngStroke,#3,idclrcoil
   bra     dwell_coil
idh0c2:
   brset   flagbyte4,#flagbyte4_oddspk,idh0c1
.ifdef MICROSQUIRT
   bclr    PTT, #0x10
.else
   bclr    PTM, #0x10
.endif
   bclr    dwellsel,#2
   bra     dwell_coil
idh0c3:
.ifdef MICROSQUIRT
   bset    PTM, #0x20
.else
   bclr    PTM, #0x20
.endif
   bclr    dwellsel,#4
   bra     dwell_coil
idh0c4:
.ifdef MICROSQUIRT
   bset    PTM, #0x10
.else
   bclr    PORTA, #0x01
.endif
   bclr    dwellsel,#8
   bra     dwell_coil
idh0c4rx8:
.ifdef MICROSQUIRT
   bset    PTM, #0x10
.else
   bclr    PORTA, #0x01
.endif

   bclr    dwellsel,#2
   bra     dwell_coil
idh0c5:
   bclr    PTAD, #0x40
   bclr    dwellsel,#0x10
   bra     dwell_coil
idh0c6:
   bclr    PTAD, #0x80
   bclr    dwellsel,#0x20
   bra     dwell_coil

; DLI
dlidwl0:
.ifdef MICROSQUIRT
   bclr    PTT, #0x20
.else
   bclr    PTM, #0x08
.endif

; only need to alter IGt (clock) output on dwell event. Select is set on spark event
;   jmp     idclrcoil


idclrcoil:
   clr     dwellsel
   rts
;*********************************************************************
checkforspk:
    brclr   TFLG1, #TFLG_ign, no_cfs
    ; stack registers that RTI will unstack
    ; return address already on the stack
    pshy
    pshx
    psha
    pshb
    pshc
    bra     ISR_Ign_TimerOut
no_cfs:
    rts
;*********************************************************************
ISR_Ign_TimerOut:
; this is   IOC2 on MS2    IOC5 on Microsquirt
   movb    #TFLG_ign, TFLG1 ; clear interrupt flag
   bclr    TIE,#TFLG_ign
.ifdef MICROSQUIRT
   ldab	   spkmode
   andb    #0xfe
   beq     edisspk
.endif

itoFIRE_COIL:
   bsr fire_coil

really_done_ignout:
   rti
;*********************************************************************
fire_coil:
   ldaa    coilsel ; save it
   brset   flash4.ICIgnOption,#0x10,nonitoilo0
   jmp     itoilo0
nonitoilo0:
   tst     coilsel
   beq     itocoil
    brset   flash4.EngStroke,#3,chkrotspk1
   brset   flagbyte11,#FLAGBYTE11_DLI4,jdli4spk0
   brset   flagbyte11,#FLAGBYTE11_DLI6,jdli6spk0
   brset   coilsel,1,ito1c1
   brset   coilsel,2,ito1c2
   brset   coilsel,4,ito1c3
   brset   coilsel,8,ito1c4
   brset   coilsel,0x10,jito1c5
   brset   coilsel,0x20,jito1c6
   bra     itocoil

jdli4spk0: jmp dli4spk0
jdli6spk0: jmp dli6spk0

chkrotspk1:
   brclr   flagbyte11,#FLAGBYTE11_RX8,ito1c1
   brset   coilsel,1,ito1c1
   brset   coilsel,2,ito1c4rx8
   bra     itocoil

ito1c1:
   bclr    coilsel,#1
    clr     dwl
ito1c1a:
   brclr   flagbyte11, #FLAGBYTE11_JS10, ito1d14
;ito1js10:
   bclr    PTT, #0x20
   bra     ito1com
ito1d14:
.ifdef MICROSQUIRT
   bset    PTM, #0x20 ; WLED; as of 2013-08-28 polarity outside ECU matches IGN1
.else
   bclr    PTM, #0x08
.endif
ito1com:
    brset   flash4.EngStroke,#3,ito1jitoc
   bra     nonitoilo0
ito1jitoc:
    bra     itocoil
ito1c2:
   bclr    coilsel,#2
    clr     dwl+1
   brset   flagbyte4,#flagbyte4_oddspk,ito1c1a
.ifdef MICROSQUIRT
   bclr    PTT, #0x10
.else
   bclr    PTM, #0x10
.endif
   bra     nonitoilo0
ito1c3:
.ifdef MICROSQUIRT
   bset    PTM, #0x20
.else
   bclr    PTM, #0x20
.endif
   bclr    coilsel,#4
    clr     dwl+2
   bra     nonitoilo0

jito1c5: bra ito1c5
jito1c6: bra ito1c6

ito1c4:
.ifdef MICROSQUIRT
   bset    PTM, #0x10
.else
   bclr    PORTA, #0x01
.endif
   bclr    coilsel,#8
    clr     dwl+3
   bra     nonitoilo0
ito1c4rx8:
.ifdef MICROSQUIRT
   bset    PTM, #0x10
.else
   bclr    PORTA, #0x01
.endif
   bclr    coilsel,#2
    clr     dwl+1
   bra     nonitoilo0
ito1c5:
   bclr    PTAD, #0x40
   bclr    coilsel,#0x10
    clr     dwl+4
   bra     nonitoilo0
ito1c6:
   bclr    PTAD, #0x80
   bclr    coilsel,#0x20
    clr     dwl+5
   bra     nonitoilo0

; DLI4
dli4spk0:
.ifdef MICROSQUIRT
   bclr    PTT, #0x20
.else
   bclr    PTM, #0x08
.endif
   brset   coilsel,1,dli4spk0a
   brset   coilsel,2,dli4spk0b
   jmp     itocoil

dli4spk0a:
.ifdef MICROSQUIRT
   bclr    PTT, #0x10
.else
   bclr    PTM, #0x10
.endif
    clr     dwl
   jmp     itocoil

dli4spk0b:
.ifdef MICROSQUIRT
   bset    PTT, #0x10
.else
   bset    PTM, #0x10
.endif
    clr     dwl+1
   jmp     itocoil

;DLI6
dli6spk0:
;IGt=1
.ifdef MICROSQUIRT
   bclr    PTT, #0x20
.else
   bclr    PTM, #0x08
.endif
   brset   coilsel,1,dli6spk0a
   brset   coilsel,2,dli6spk0b
   brset   coilsel,4,dli6spk0c
   jmp     itocoil

dli6spk0a:
;IGdA = 0 , IGdB = 1
.ifdef MICROSQUIRT
   bclr    PTT, #0x10
   bclr    PTM, #0x20
.else
   bclr    PTM, #0x10
   bset    PTM, #0x20
.endif
    clr     dwl
   jmp     itocoil

dli6spk0b:
;IGdA = 0 , IGdB = 0
.ifdef MICROSQUIRT
   bclr    PTT, #0x10
   bset    PTM, #0x20
.else
   bclr    PTM, #0x10
   bclr    PTM, #0x20
.endif
    clr     dwl+1
   jmp     itocoil

dli6spk0c:
;IGdA = 1 , IGdB = 0
.ifdef MICROSQUIRT
   bset    PTT, #0x10
   bset    PTM, #0x20
.else
   bset    PTM, #0x10
   bclr    PTM, #0x20
.endif
    clr     dwl+2
   jmp     itocoil

;other case
itoilo0:
   tst     coilsel
   beq     itocoil
    brset   flash4.EngStroke,#3,chkrotspk2
   brset   flagbyte11,#FLAGBYTE11_DLI4,jdli4spk1
   brset   flagbyte11,#FLAGBYTE11_DLI6,jdli6spk1
   brset   coilsel,1,ito0c1
   brset   coilsel,2,ito0c2
   brset   coilsel,4,ito0c3
   brset   coilsel,8,jito0c4
   brset   coilsel,0x10,jito0c5
   brset   coilsel,0x20,jito0c6
   bra     itocoil

jdli4spk1: jmp dli4spk1
jdli6spk1: jmp dli6spk1
jito0c4:   jmp ito0c4
jito0c5:   jmp ito0c5
jito0c6:   jmp ito0c6

chkrotspk2:
   brclr   flagbyte11,#FLAGBYTE11_RX8,ito0c1
   brset   coilsel,1,ito0c1
   brset   coilsel,2,ito0c4rx8
   bra     itocoil

ito0c1:
ito0c1a:
   brclr   flagbyte11, #FLAGBYTE11_JS10, ito0c1d14
ito0c1js10:
   bset    PTT, #0x20
   bclr    coilsel,#1
    bra ito0c1com
ito0c1d14:
.ifdef MICROSQUIRT
   bclr    PTM, #0x20 ; WLED; as of 2013-08-28 polarity outside ECU matches IGN1
.else
   bset    PTM, #0x08
.endif
   bclr    coilsel,#1
ito0c1com:
    clr     dwl
    brset   flash4.EngStroke,#3,ito0jitoc
   bra     itoilo0 ; not rotary, loop
ito0jitoc:
   jmp     itocoil ; is rotary, done
ito0c2:
   brset   flagbyte4,#flagbyte4_oddspk,ito0c1a
.ifdef MICROSQUIRT
   bset    PTT, #0x10
.else
   bset    PTM, #0x10
.endif
   bclr    coilsel,#2
    clr     dwl+1
   bra     itoilo0
ito0c3:
.ifdef MICROSQUIRT
   bclr    PTM, #0x20
.else
   bset    PTM, #0x20
.endif
   bclr    coilsel,#4
    clr     dwl+2
   bra     itoilo0
ito0c4:
.ifdef MICROSQUIRT
   bclr    PTM, #0x10
.else
   bset    PORTA, #0x01
.endif
   bclr    coilsel,#8
    clr     dwl+3
   bra     itoilo0

ito0c4rx8:
.ifdef MICROSQUIRT
   bclr    PTM, #0x10
.else
   bset    PORTA, #0x01
.endif
   bclr    coilsel,#2
    clr     dwl+1
   bra     itoilo0
ito0c5:
   bset    PTAD, #0x40
   bclr    coilsel,#0x10
     clr     dwl+4
  bra     itoilo0
ito0c6:
   bset    PTAD, #0x80
   bclr    coilsel,#0x20
    clr     dwl+5
   bra     itoilo0

; DLI4
dli4spk1:
.ifdef MICROSQUIRT
   bset    PTT, #0x20
.else
   bset    PTM, #0x08
.endif
   brset   coilsel,1,dli4spk1a
   brset   coilsel,2,dli4spk1b
   jmp     itocoil

dli4spk1a:
.ifdef MICROSQUIRT
   bset    PTT, #0x10
.else
   bset    PTM, #0x10
.endif
    clr     dwl
   jmp     itocoil

dli4spk1b:
.ifdef MICROSQUIRT
   bclr    PTT, #0x10
.else
   bclr    PTM, #0x10
.endif
    clr     dwl+1
   jmp     itocoil

;DLI6
dli6spk1:
;IGt=1
.ifdef MICROSQUIRT
   bset    PTT, #0x20
.else
   bset    PTM, #0x08
.endif
   brset   coilsel,1,dli6spk1a
   brset   coilsel,2,dli6spk1b
   brset   coilsel,4,dli6spk1c
   jmp     itocoil

dli6spk1a:
;IGdA = 0 , IGdB = 1
.ifdef MICROSQUIRT
   bset    PTT, #0x10
   bset    PTM, #0x20
.else
   bset    PTM, #0x10
   bclr    PTM, #0x20
.endif
    clr     dwl
   jmp     itocoil

dli6spk1b:
;IGdA = 0 , IGdB = 0
.ifdef MICROSQUIRT
   bset    PTT, #0x10
   bclr    PTM, #0x20
.else
   bset    PTM, #0x10
   bset    PTM, #0x20
.endif   
    clr     dwl+1
   jmp     itocoil

dli6spk1c:
;IGdA = 1 , IGdB = 0
.ifdef MICROSQUIRT
   bclr    PTT, #0x10
   bclr    PTM, #0x20
.else
   bclr    PTM, #0x10
   bset    PTM, #0x20
.endif
    clr     dwl+2
   jmp     itocoil

itocoil:
   ldab    spkmode
   cmpb    #14
   beq     is14
   andb    #0xfe
   cmpb    #2
   bne     chk_tas
is14:
   ldx     dwell_us
   tbeq    x,itccl
   staa    dwellsel
   exg     x,d
   bra     tas_set

chk_tas:
   ldab    flash4.dwellmode
   cmpb    #2
   bne     itccl
   staa    dwellsel ; previously saved before clearing it
   ldaa    #100
   ldab    flash4.dwelltime
   mul
tas_set:
   addd    TC_ign
   std     TC_dwl           ; set up dwell timer for prescribed time later
   bset    TIE,#TFLG_dwl
   movb    #TFLG_dwl,TFLG1
itccl:
   clr     coilsel
   rts


;*********************************************************************
ISR_TC5:
; this is   IOC5 on MS2    IOC2 on Microsquirt
   movb    #TFLG_trig2, TFLG1 ; clear interrupt flag

.ifndef MICROSQUIRT
   ldab	   spkmode
   andb    #0xfe
   beq     edisspk
.endif

; second trigger input
; may want to add tooth width recording like the start of ign_in
; for now simply set the flag to say second trigger happened
; The input capture setup determines when we arrive here

; Need to do these after the noise filtering
;   bset    flagbyte1,#flagbyte1_trig2active
   bset    TIE, #TFLG_trig2  ; ensure IC still enabled
;   inc     trig2cnt

   brclr   flagbyte2,#flagbyte2_twintrig,tc5notwin
   bset    flagbyte2,#flagbyte2_twintrignow
   jmp     ISR_Ign_TimerIn   ; CAUTION! Jumping to timerin

tc5notwin:
   ; this is the normal code path

   ; As with the crank input tach path is
   ;  * 1. if cam tach masking is enabled, we might not even have reached this ISR
   ;  * (composite tooth logger happens here)
   ;  * 2. 2nd trig noise filter
   ;  * 3. if noise filter off, polarity check
   ;  * 4. cam period filtering

   ; noise filter

   brset flagbyte5,FLAGBYTE5_CAM_NOISE,noise_filter
   brset flagbyte0, #FLAGBYTE0_COMPLOG,noise_filter
   jmp   skip_nf

; Need 32-bit TC5 (MS2) or TC2 (Mircosquirt), so generate that
noise_filter: ; (this includes the composite logger)

   movw    swtimer,TC5_32bits
   movw    TC_trig2,TC5_32bits+2

   brclr   flagbyte1,#flagbyte1_ovfclose,ovf_check_nointyet
   ldd     TC5_32bits+2
   cmpd    #0x1000
   bhs     ovf_check_nointyet
   bra     extra_inc_TC532bits

ovf_check_nointyet:
   ldd     TC5_32bits+2
   cmpd     TC5_last
   bhs     done_ovf_tc5
   ldd     swtimer
   cmpd     swtimer_TC5_last
   bne     done_ovf_tc5

extra_inc_TC532bits:
   inc     TC5_32bits

done_ovf_tc5:
   movw    TC5_32bits+2,TC5_last
   movw    swtimer,swtimer_TC5_last

;composite tooth logger
   brset   flagbyte0, #FLAGBYTE0_COMPLOG, do_ic2complog
   jmp     cl2done ; skip if not doing composite log

do_ic2complog:
    ldx     TC5_32bits
    ldd     TC5_32bits+2
    subd    IC_last+2
    xgdx
    sbcb    IC_last+1
    sbca    IC_last

;D contains high word of time since last edge (pri or sec)
;X contains low word
    movw    TC5_32bits, IC_last ; save this timer time
    movw    TC5_32bits+2, IC_last+2

    xgdy    ; don't trash D
    ldd	    #ram_data
    addd	log_offset
    xgdy    ; swap back
    ; ignore top byte in A
    andb	#0xf
    brclr	synch, #0x01, cl2not_sync   ; HARDCODING
    orab	#0x10

cl2not_sync:
    orab	#0x20 ; always tach2

    brclr   PTT,#1,cl2low1
    orab	#0x40   ; store pri trig pin level in 0x40

cl2low1:
    brclr   PTT,#TFLG_trig2,cl2low2
    orab	#0x80   ; store 2nd trig pin level in 0x80

cl2low2:
    stab	0,Y ; top byte of time + 4 special bits
    stx	    1,Y ; low word

    ldab    page
    cmpb    #0xf2
    beq     cl2end1
;comp log loop mode

    ldd     log_offset
    std     ram_data + 0x3fd ; store current log_offset as pointer to next data point
    brclr   synch, #1, cl2fin ; no sync.. we are done

cll2inc:
    ldd	    log_offset
    addd	#3
    std	    log_offset
    cpd	    #0x3fc   ; three less
    bls	    cl2done
;start again
    clr     log_offset
    clr     log_offset+1
    bra     cl2done

cl2end1:
    ldd	    log_offset
    addd	#3
    std	    log_offset
    cpd	    #0x3ff
    bls	    cl2done

cl2fin:
    ; we've reached the end of the buffer, stop
    bclr	flagbyte0, #FLAGBYTE0_COMPLOG
    movb	#1, ram_data + 0x3ff ; HARDCODED version
    bset    outpc.status3, #STATUS3_DONELOG

cl2done:
   ldd   outpc.rpm
   cmpd  #10 ; check over 10rpm
   blo   skip_nf
   brset flagbyte5,#FLAGBYTE5_CAM_NOISE,real_noise_filter

skip_nf:
   brclr flagbyte5,#FLAGBYTE5_CAM_POLARITY,cpol_done ; polarity check off

; polarity check
; mode4 has its own pair of bits, everything else follows main polarity
   ldaa  spkmode
   cmpa  #4
   beq   nf4
;other modes
   brset flash4.ICIgnOption, #0x01, nf_rise ; rising edge
   bra   nf_fall

nf4:
;mode4 where it can be rising OR falling
;init code disables this check for rising AND falling
   brset flash4.spk_config, #0x10, nf_rise
   brset flash4.spk_config, #0x20, nf_fall
;shouldn't get here...bail
   bra  cpol_bail

nf_fall:
   brclr PORTT, #TFLG_trig2, cpol_done ; input pin is low
   bra   cpol_bail
nf_rise:
   brset PORTT, #TFLG_trig2, cpol_done ; input pin is high
cpol_bail:
;input pin was wrong polarity - bail out
   rti

cpol_done:
   jmp   no_noise_filter


; ok, now figure out what edge we're on, and what edge we're looking for
real_noise_filter:
   brclr   PTT,#TFLG_trig2,caught_fall

   ; rise, are we triggering on this or not?

   brset   flash4.spk_config,#0x20,not_triggering
   bra     triggering 

caught_fall:
   brset   flash4.spk_config,#0x10,not_triggering
   bra     triggering

not_triggering:
   ; Not triggering, store the time and exit the interrupt
   movw    TC5_32bits,TC5_trig_firstedge
   movw    TC5_32bits+2,TC5_trig_firstedge+2
   rti

triggering:
   ; triggering, see if the time is large enough to not be noise
   ldd     TC5_32bits+2
   subd    TC5_trig_firstedge+2
   xgdx
   ldd     TC5_32bits
   sbcb    TC5_trig_firstedge+1
   sbca    TC5_trig_firstedge
   bne     no_noise_filter
   xgdx
   cmpd    flash4.TC5_required_width
   bhi     no_noise_filter    ;filter passes, actual length is more than required

unset_bit_rti:
   bclr    flagbyte1,#flagbyte1_trig2active
   rti

no_noise_filter:
   movw    lmms, ltch_lmms2 ; save lmms value for false trig detection
   movw    lmms+2, ltch_lmms2+2 ; not really needed as lmms will not change while we are in here

   ldd     false_period_cam_tix
   beq     no_false_cam   ; skip if zero

   ldd     TC_trig2
   subd    TC_trig2_last
   cmpd    false_period_cam_tix
   bhi     no_false_cam
   bclr    flagbyte1,#flagbyte1_trig2active
   rti     ; assume this is a false trigger - bail out  

no_false_cam:
; If we got here this is considered a real pulse
   bset    flagbyte1,#flagbyte1_trig2active
   inc     trig2cnt
   movw    TC_trig2_last, TC_trig2_last2
   movw    TC_trig2, TC_trig2_last

   jmp     L1 ; goes to rti

edisspk:        ; EDIS spark output mode - always IOC5
    ; Enter here when ign OC reg match
   ldab    TCTL1
   andb    #4
   lsrb
   lsrb
   stab    IgnOCpinstate ; this only needs 1 bit
   cmpb    CHG
   bne     LM11

; set up dwell monitor timer
   movb    #1,dwl  ; always channel A at the moment

;	IgnTimerComp = TC5 + coil_dur_set;  // 2/3 us
   ldd     TC5
   addd    coil_dur_set+0x2
   ldx     coil_dur_set
   bcc     LM9b
   inx
LM9b:
   std     IgnTimerComp+0x2
   stx     IgnTimerComp

   movb    SPK, ign_setpin
   bra     LM16


LM11:
;	// Coil has just started discharging (sparking)

; clear dwell monitor timer
   clr     dwl  ; always channel A at the moment

LM12:
   bclr    TIE,#0x20 ;  disable ign OC interrupt - chge after next IC pulse
   jmp     L40 ; clear ign OC interrupt flag

schd_dwl:
	; want to charge after done with spark
;	    IgnTimerComp = TC5 + charge_time;  // 2/3 us
   ldx     charge_time
   ldd     TC5
   addd    charge_time+0x2
   bcc     LM14b
   inx
LM14b:
   std     IgnTimerComp+0x2
   stx     IgnTimerComp

   movb    CHG, ign_setpin ; use to set OC o/p in OL5

LM16:
;    // check if v. short OC reg occurs after TCNT
;There must be a cleaner way of doing this...
   ldx    #0
   ldd    TCNT
   subd   TC5
   bcc    LM18
   inx           ; rolled over between start and now so increment top word
LM18:
   addd   #12
   bcc    LM18b
   inx
LM18b:
   addd   TC5
   bcc    LM18c
   inx
LM18c:
; x:d now contains target + 12 ticks buffer
   cpx    IgnTimerComp
   bcs    LM20
   bhi    LM19b
   cpd    IgnTimerComp+0x2
   bls    LM20
;    if(IgnTimerComp < tcnt)IgnTimerComp = tcnt;
LM19b:
   std    IgnTimerComp+0x2
   stx    IgnTimerComp

LM20:
; We only get here in EDIS which is scheduled off trigger so
; will never require > 43ms delay

LM24:
   movw    IgnTimerComp+0x2, TC5   ; load ign OC register

;	// enable Ign OC pin
   tst     ign_setpin     ; either 0 or 1
   beq     LM24a

   bset    TCTL1,#0x04    ; fixed spk output for EDIS
   bra     LM24b
LM24a:
   bclr    TCTL1,#0x04
LM24b:

L40:
   movb    #TFLG_trig2, TFLG1; 	// clear ign OC interrupt flag
   bra     ign_rti

L1:
   ldd     false_mask_cam
   beq     ign_no_false
; cam sensor false trigger protection
   addd	   ltch_lmms2+0x2
   ldx     ltch_lmms2
   bcc	   L1carry
   inx
L1carry:
   stx     t_enable_IC2
   std     t_enable_IC2+0x2

   bclr    TIE, #TFLG_trig2
   movb	   #TFLG_trig2, TFLG1
   bra	   ign_rti

ign_no_false:
    movw	#0xffff, t_enable_IC2+0x2
    movw	#0xffff, t_enable_IC2

ign_rti:
   rti


; composite logger moved to here from ign_in.c due to gcc mess up

do_complog_pri:
; function call does this, we arrive here with this data
;    ldx     TC0_32bits 
;    ldd     TC0_32bits+2
    subd    IC_last+2
    xgdx
    sbcb    IC_last+1
    sbca    IC_last

;D contains high word of time since last edge (pri or sec)
;X contains low word
;    movw    TC0_32bits, IC_last ; save this timer time ; do this in the C code
;    movw    TC0_32bits+2, IC_last+2

    xgdy    ; don't trash D
    ldd	    #ram_data
    addd	log_offset
    xgdy    ; swap back
    ; ignore top byte in A
    andb	#0xf
    brclr	synch, #0x01, cl1not_sync   ; HARDCODING
    orab	#0x10

cl1not_sync:
    brclr   flagbyte2, #flagbyte2_twintrignow, cl1ns2
    orab	#0x20 ; if tach2 from twin trigger?

cl1ns2:
    brclr   PTT,#1,cl1low1
    orab	#0x40   ; store pri trig pin level in 0x40

cl1low1:
    brclr   PTT,#TFLG_trig2,cl1low2
    orab	#0x80   ; store 2nd trig pin level in 0x80

cl1low2:
    stab	0,Y ; top byte of time + 4 special bits
    stx	    1,Y ; low word

    ldab    page
    cmpb    #0xf2
    beq     cl1end1
;comp log loop mode
    ldd     log_offset
    std     ram_data + 0x3fd ; store current log_offset as pointer to next data point
    brclr   synch, #1, cl1fin  ; no sync.. we are done

cll1inc:
    ldd	    log_offset
    addd	#3
    std	    log_offset
    cpd	    #0x3fc   ; three less
    bls	    cl1done
;start again
    clr     log_offset
    clr     log_offset+1
    bra     cl1done

cl1end1:
    ldd	    log_offset
    addd	#3
    std	    log_offset
    cpd	    #0x3ff
    bls	    cl1done

cl1fin:
    ; we've reached the end of the buffer, stop
    bclr	flagbyte0, #FLAGBYTE0_COMPLOG
    movb	#1, ram_data + 0x3ff ; HARDCODED version
    bset    outpc.status3, #STATUS3_DONELOG

cl1done:
    rts

;*********************************************************************
checkfortimerin:
    brclr   TFLG1, #1, no_cfti
    ; stack registers that RTI will unstack
    ; return address already on the stack
    pshy
    pshx
    psha
    pshb
    pshc
    jmp     ISR_Ign_TimerIn
no_cfti:
    rts
;*********************************************************************
checkforsci:
    brclr   SCI0SR1, #0x20, no_cfsci
    ; stack registers that RTI will unstack
    ; return address already on the stack
    pshy
    pshx
    psha
    pshb
    pshc
    jmp     ISR_SCI_Comm
no_cfsci:
    rts

.sect .text
random_no:
    fcb 0xb2, 0x8a, 0x29, 0x54, 0x48, 0x9a, 0x0a, 0xbc, 0xd5, 0x0e, 0x18, 0xa8, 0x44, 0xac, 0x5b, 0xf3
    fcb 0x8e, 0x4c, 0xd7, 0x2d, 0x9b, 0x09, 0x42, 0xe5, 0x06, 0xc4, 0x33, 0xaf, 0xcd, 0xa3, 0x84, 0x7f 
    fcb 0x2d, 0xad, 0xd4, 0x76, 0x47, 0xde, 0x32, 0x1c, 0xec, 0x4a, 0xc4, 0x30, 0xf6, 0x20, 0x23, 0x85 
    fcb 0x6c, 0xfb, 0xb2, 0x07, 0x04, 0xf4, 0xec, 0x0b, 0xb9, 0x20, 0xba, 0x86, 0xc3, 0x3e, 0x05, 0xf1 
    fcb 0xec, 0xd9, 0x67, 0x33, 0xb7, 0x99, 0x50, 0xa3, 0xe3, 0x14, 0xd3, 0xd9, 0x34, 0xf7, 0x5e, 0xa0 
    fcb 0xf2, 0x10, 0xa8, 0xf6, 0x05, 0x94, 0x01, 0xbe, 0xb4, 0xbc, 0x44, 0x78, 0xfa, 0x49, 0x69, 0xe6 
    fcb 0x23, 0xd0, 0x1a, 0xda, 0x69, 0x6a, 0x7e, 0x4c, 0x7e, 0x51, 0x25, 0xb3, 0x48, 0x84, 0x53, 0x3a 
    fcb 0x94, 0xfb, 0x31, 0x99, 0x90, 0x32, 0x57, 0x44, 0xee, 0x9b, 0xbc, 0xe9, 0xe5, 0x25, 0xcf, 0x08 
    fcb 0xf5, 0xe9, 0xe2, 0x5e, 0x53, 0x60, 0xaa, 0xd2, 0xb2, 0xd0, 0x85, 0xfa, 0x54, 0xd8, 0x35, 0xe8 
    fcb 0xd4, 0x66, 0x82, 0x64, 0x98, 0xd9, 0xa8, 0x87, 0x75, 0x65, 0x70, 0x5a, 0x8a, 0x3f, 0x62, 0x80 
    fcb 0x29, 0x44, 0xde, 0x7c, 0xa5, 0x89, 0x4e, 0x57, 0x59, 0xd3, 0x51, 0xad, 0xac, 0x86, 0x95, 0x80 
    fcb 0xec, 0x17, 0xe4, 0x85, 0xf1, 0x8c, 0x0c, 0x66, 0xf1, 0x7c, 0xc0, 0x7c, 0xbb, 0x22, 0xfc, 0xe4 
    fcb 0x66, 0xda, 0x61, 0x0b, 0x63, 0xaf, 0x62, 0xbc, 0x83, 0xb4, 0x69, 0x2f, 0x3a, 0xff, 0xaf, 0x27 
    fcb 0x16, 0x93, 0xac, 0x07, 0x1f, 0xb8, 0x6d, 0x11, 0x34, 0x2d, 0x8d, 0xef, 0x4f, 0x89, 0xd4, 0xb6 
    fcb 0x63, 0x35, 0xc1, 0xc7, 0xe4, 0x24, 0x83, 0x67, 0xd8, 0xed, 0x96, 0x12, 0xec, 0x45, 0x39, 0x02 
    fcb 0xd8, 0xe5, 0x0a, 0xf8, 0x9d, 0x77, 0x09, 0xd1, 0xa5, 0x96, 0xc1, 0xf4, 0x1f, 0x95, 0xaa, 0x82

