; $Id: ms2_extra_burner.s,v 1.15 2013/11/21 13:58:25 jsmcortina Exp $

; * Copyright 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013
; * James Murray and Kenneth Culver
; *
; * This file is a part of MS2/Extra.
; *
; * Origin: Al Grippo
; * Major: Recode in ASM and extend. James Murray
; * Majority: James Murray
; *
; * You should have received a copy of the code LICENSE along with this source,
; * ask on the www.msextra.com forum if you did not.
; *

.sect .text
.globl burntbl

;.nolist
include "s12asmdefs.inc"
include "ms2extra_structs.inc"
;.list

;*********************************************************************
; burn a ram table to flash
; ram table always at same place ram_data
; flash location in lookup table
; argument in D gives offset into flash table (used for calibration tables)
;
;*********************************************************************
burntbl:
       pshd
       ldaa    PPAGE
       psha
       pshc

       ldaa    flocker
       cmpa    #0xcc
       bne     burnend
burnok:
       ldab    burn_idx
       cmpb    #4
       bhs     pp_ok
       movb    #0x3c,PPAGE ; calibration tables are in this PPAGE
pp_ok:
       ldaa    #6
       mul
       tfr      d,x
       ldd      tables+2,x ; get flash address
       addd     2,sp ; original D value
;range check
        cpd     #0x4000
        blo     burnend
        cpd     #0xbfff
        bhi     burnend
        tfr     d,x

       sei      ; disable interrupts
       brclr   FSTAT,#CBEIF,.   ; loop until no command in action 
;erase the 1k sector
       ldaa    FSTAT
       anda    #0x30
       beq     burnerase
       movb    #ACCERR|PVIOL,FSTAT
burnerase:
       ldd     #0xffff
       std     0,x
       movb    #SecErase,FCMD
       ldaa    #CBEIF
       jsr     RamBurnPgm

       ldy     #0  ; burn loop counter
burnlp:
       movb    #ACCERR|PVIOL,FSTAT
       ldd     ram_data,y  ; load/write a word at a time
       std     2,x+
       movb    #ProgWord,FCMD
       ldaa    #CBEIF
       jsr     RamBurnPgm

       iny
       iny
       cmpy    #0x400
       bne     burnlp
burnend:
       pulc ; restore interrupt enable/disable
       pula
       staa    PPAGE
       puld

       rts

