;*********************************************************************
; MS2 Extra equates for asm   (C) 2006 James Murray
;*********************************************************************
;global vars used in asm
; $Id: ms2extrah.inc,v 1.50 2013/01/23 18:49:20 jsmcortina Exp $

.include "us_opt_asm.inc"

.include "s12asmdefs.inc"
.include "ms2extra_structs.inc"
.include "ms2_extra_defines.inc"

; ignition definitions to swap timer interrupts TC2/TC5 if MS2 vs. Microsquirt
.ifndef MICROSQUIRT
.set TC_ign,TC7     ; ***JB was TC2
.set TFLG_ign,0x80  ; ***JB was 0x04
.set TC_trig2,TC5
.set TFLG_trig2,0x20
.set TC_rotINJ3,TC2
.set TFLG_rotINJ3,0x04
.set TC_rotINJ4,TC4
.set TFLG_rotINJ4,0x10
.set TC_dwl,TC6
.set TFLG_dwl,0x40
.else
.set TC_ign,TC5
.set TFLG_ign,0x20
.set TC_trig2,TC2
.set TFLG_trig2,0x04
.set TC_rotINJ3,TC6
.set TFLG_rotINJ3,0x40
.set TC_rotINJ4,TC7
.set TFLG_rotINJ4,0x80
.set TC_dwl,TC4
.set TFLG_dwl,0x10
.endif

.equ COILABIT,0x1
.equ COILBBIT,0x2
.equ COILCBIT,0x4
.equ COILDBIT,0x8
.equ COILEBIT,0x10
.equ COILFBIT,0x20
.equ COILGBIT,0x40
.equ COILHBIT,0x80

.macro STACK_SOFT
;these are the minimum to stack
movw 0x3000, 2, -SP
movw 0x3002, 2, -SP
movw 0x3004, 2, -SP
.endm

.macro UNSTACK_SOFT
;these are the minimum to stack
movw 2, SP+, 0x3004
movw 2, SP+, 0x3002
movw 2, SP+, 0x3000
.endm
